/* Tabela CCTBIMPFORN: */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na
tabela CCTBIMPFORN */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela CCTBIMPFORN utilizando
a tabela Geral de Logs de Operaes */

CREATE OR REPLACE TRIGGER LOG_GER_CTBIMPTPOPER
AFTER DELETE OR INSERT OR UPDATE
ON CTBIMPTPOPER FOR EACH ROW
DECLARE
  V_USUARIO      VARCHAR2(40);
  V_TIPO         VARCHAR2(1);
  V_ITPESQ       VARCHAR2(40);
  V_DESC         VARCHAR2(300);
  V_DTOPER       DATE;
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
BEGIN
   V_TIPO := '0';
   V_DESC := '';

   WEBTUNNING(V_DSREMOTEADDR,
           V_DSREMOTEHOST,
           V_DSSERVERRDM,
           V_DSSERVMETHOD,
           V_DSREMOTEOPER);

   IF DELETING THEN
      IF :OLD.IDENTRSAIDOP IS NOT NULL THEN
         V_DESC := V_DESC || 'Entr/Saida=' || :OLD.IDENTRSAIDOP;
      END IF;

      IF :OLD.CDTIPOOPER IS NOT NULL THEN
         V_DESC := V_DESC || ' TpOper=' || :OLD.CDTIPOOPER;
      END IF;

      IF :OLD.CDIMPOSTO IS NOT NULL THEN
         V_DESC := V_DESC || ' CodImp=' || :OLD.CDIMPOSTO;
      END IF;

      IF :OLD.CDCCTBATIVTO IS NOT NULL THEN
         V_DESC := V_DESC || ' A recup=' || :OLD.CDCCTBATIVTO;
      END IF;

      IF :OLD.CDCCTBDADMTO IS NOT NULL THEN
         V_DESC := V_DESC || ' DespTrib=' || :OLD.CDCCTBDADMTO;
      END IF;

      IF :OLD.CDCCTBPASSTO IS NOT NULL THEN
         V_DESC := V_DESC || ' A recol=' || :OLD.CDCCTBPASSTO;
      END IF;

      IF :OLD.CDCCTBDESPTO IS NOT NULL THEN
         V_DESC := V_DESC || ' SobVenda=' || :OLD.CDCCTBDESPTO;
      END IF;

      V_TIPO         := '3';
      V_ITPESQ       := :OLD.CDIMPOSTO || :OLD.IDENTRSAIDOP || :OLD.CDTIPOOPER;
   ELSE
      IF UPDATING THEN
         IF (:OLD.IDENTRSAIDOP  <> :NEW.IDENTRSAIDOP) OR
            (:OLD.CDTIPOOPER    <> :NEW.CDTIPOOPER)   OR
            (:OLD.CDIMPOSTO     <> :NEW.CDIMPOSTO)    OR
            (NVL(:OLD.CDCCTBATIVTO,'!')  <> NVL(:NEW.CDCCTBATIVTO,'!')) OR
            (NVL(:OLD.CDCCTBDADMTO,'!')  <> NVL(:NEW.CDCCTBDADMTO,'!')) OR
            (NVL(:OLD.CDCCTBPASSTO,'!')  <> NVL(:NEW.CDCCTBPASSTO,'!')) OR
            (NVL(:OLD.CDCCTBDESPTO,'!')  <> NVL(:NEW.CDCCTBDESPTO,'!')) THEN

            V_TIPO         := '2';
            V_ITPESQ       := :OLD.CDIMPOSTO || :OLD.IDENTRSAIDOP || :OLD.CDTIPOOPER;

            IF NVL(:OLD.IDENTRSAIDOP,'') <>  NVL(:NEW.IDENTRSAIDOP,'') THEN
               V_DESC := V_DESC || 'Entr/Saida=' || :NEW.IDENTRSAIDOP;
            END IF;

            IF NVL(:OLD.CDTIPOOPER,'') <> NVL(:NEW.CDTIPOOPER,'') THEN
               V_DESC := V_DESC || ' TpOper=' || :NEW.CDTIPOOPER;
            END IF;

            IF NVL(:OLD.CDIMPOSTO,'') <> NVL(:NEW.CDIMPOSTO,'') THEN
               V_DESC := V_DESC || ' CodImp=' || :NEW.CDIMPOSTO;
            END IF;

            IF NVL(:OLD.CDCCTBATIVTO,'!') <> NVL(:NEW.CDCCTBATIVTO,'!') THEN
               V_DESC := V_DESC || ' A recup=' || :NEW.CDCCTBATIVTO;
            END IF;

            IF NVL(:OLD.CDCCTBDADMTO,'!') <> NVL(:NEW.CDCCTBDADMTO,'!') THEN
               V_DESC := V_DESC || ' DespTrib=' || :NEW.CDCCTBDADMTO;
            END IF;

            IF NVL(:OLD.CDCCTBPASSTO,'!') <> NVL(:NEW.CDCCTBPASSTO,'!') THEN
               V_DESC := V_DESC || ' A recol=' || :NEW.CDCCTBPASSTO;
            END IF;

            IF NVL(:OLD.CDCCTBDESPTO,'!') <> NVL(:NEW.CDCCTBDESPTO,'!') THEN
               V_DESC := V_DESC || ' SobVenda=' || :NEW.CDCCTBDESPTO;
            END IF;
         END IF;
      ELSE
         V_TIPO         := '1';
         V_ITPESQ       := :NEW.CDIMPOSTO || :NEW.IDENTRSAIDOP || :NEW.CDTIPOOPER;
         IF :NEW.IDENTRSAIDOP IS NOT NULL THEN
            V_DESC := V_DESC || 'Entr/Saida=' || :NEW.IDENTRSAIDOP;
         END IF;

         IF :NEW.CDTIPOOPER IS NOT NULL THEN
            V_DESC := V_DESC || ' TpOper=' || :NEW.CDTIPOOPER;
         END IF;

         IF :NEW.CDIMPOSTO IS NOT NULL THEN
            V_DESC := V_DESC || ' CodImp=' || :NEW.CDIMPOSTO;
         END IF;

         IF :NEW.CDCCTBATIVTO IS NOT NULL THEN
            V_DESC := V_DESC || ' A recup=' || :NEW.CDCCTBATIVTO;
         END IF;

         IF :NEW.CDCCTBDADMTO IS NOT NULL THEN
            V_DESC := V_DESC || ' DespTrib=' || :NEW.CDCCTBDADMTO;
         END IF;

         IF :NEW.CDCCTBPASSTO IS NOT NULL THEN
            V_DESC := V_DESC || ' A recol=' || :NEW.CDCCTBPASSTO;
         END IF;

         IF :NEW.CDCCTBDESPTO IS NOT NULL THEN
            V_DESC := V_DESC || ' SobVenda=' || :NEW.CDCCTBDESPTO;
         END IF;
      END IF;
   END IF;

   IF V_TIPO <> '0' THEN
      NMUSUARIO(V_USUARIO);
      IF NOT V_DESC IS NULL THEN
         IF NOT V_USUARIO IS NULL THEN
            V_DTOPER := SYSDATE;

            INSERT INTO LOGOPERA
               (NMTABELA,   DTOPERACAO, NMRESPOPER,
                IDTIPOOPER, CDPESQITEM, DSOPERACAO,
                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER)
            VALUES
               ('CTBIMPTPOPER',  V_DTOPER, V_USUARIO,
                V_TIPO,      V_ITPESQ, V_DESC,
                V_DSREMOTEADDR, V_DSREMOTEHOST, V_DSSERVERRDM,V_DSSERVMETHOD, V_DSREMOTEOPER);
         END IF;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_GER_CTBIMPTPOPER','4.09.060'); END;
/

