/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_TPSV                                                     */
/* Tabela : TIPOSERV                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 04/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_TPSV'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_TPSV
GO

CREATE TRIGGER DTULTATU_TPSV
ON TIPOSERV
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'TIPOSERV', null, 'CDTIPOSERV=' + CDTIPOSERV + ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE TIPOSERV
      SET DTULTATUTPSV = GETDATE()
      FROM INSERTED;
   END;
END;
GO

